commit eb39a357cb57fdf83b89c9039dd6e7a7983fd5df
Merge: d997c8cd3 dddc92898
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Tue Oct 28 13:26:04 2025 +0000

    Merge branch '4.next'

diff --git a/src/OS/Makefile-Base b/src/OS/Makefile-Base
index 5a15b0a6b..e24ef95f2 100644
--- a/src/OS/Makefile-Base
+++ b/src/OS/Makefile-Base
@@ -539,8 +539,7 @@ transport-filter.pl: config ../src/transport-filter.src
 # are thrown away by the linker.
 
 OBJ_WITH_CONTENT_SCAN = malware.o mime.o regex.o spam.o spool_mbox.o
-OBJ_EXPERIMENTAL =	bmi_spam.o \
-			dane.o \
+OBJ_EXPERIMENTAL =	dane.o \
 			dcc.o \
 			imap_utf7.o \
 			utf8.o \
@@ -938,7 +937,6 @@ spool_mbox.o:    $(HDRS) spool_mbox.c
 
 # Dependencies for EXPERIMENTAL_* modules
 
-bmi_spam.o:	$(HDRS) bmi_spam.c
 dane.o:		$(HDRS) dane.c dane-openssl.c
 dcc.o:		$(HDRS) dcc.h dcc.c
 imap_utf7.o:	$(HDRS) imap_utf7.c
diff --git a/src/exim_monitor/em_globals.c b/src/exim_monitor/em_globals.c
index 491a9dda6..5627a2277 100644
--- a/src/exim_monitor/em_globals.c
+++ b/src/exim_monitor/em_globals.c
@@ -44,11 +44,6 @@ uschar  actioned_message[24];
 uschar *action_required;
 uschar *alternate_config = NULL;
 
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-int     bmi_run                = 0;
-uschar *bmi_verdicts           = NULL;
-#endif
-
 int     body_max = 20000;
 
 uschar *exim_path              = US BIN_DIRECTORY "/exim"
diff --git a/src/scripts/MakeLinks b/src/scripts/MakeLinks
index d35962f98..8f55be0b5 100755
--- a/src/scripts/MakeLinks
+++ b/src/scripts/MakeLinks
@@ -32,9 +32,9 @@ d="lookups"
 mkdir $d
 cd $d
 # Makefile is generated
-for f in README cdb.c dbmdb.c dnsdb.c dsearch.c ibase.c json.c ldap.c \
+for f in README cdb.c dbmdb.c dnsdb.c dsearch.c json.c ldap.c \
   lmdb.c lsearch.c mysql.c nis.c nisplus.c nmh.c oracle.c passwd.c \
-  pgsql.c readsock.c redis.c spf.c sqlite.c testdb.c whoson.c \
+  pgsql.c psl.c readsock.c redis.c spf.c sqlite.c testdb.c whoson.c \
   lf_functions.h lf_check_file.c lf_quote.c lf_sqlperform.c
 do
   ln -s ../../src/$d/$f $f
@@ -155,7 +155,7 @@ do
 done
 
 # EXPERIMENTAL_*
-for f in  bmi_spam.c bmi_spam.h dcc.c dcc.h dane.c dane-openssl.c \
+for f in  dcc.c dcc.h dane.c dane-openssl.c \
   danessl.h imap_utf7.c utf8.c xclient.c
 do
   ln -s ../src/$f $f
diff --git a/src/scripts/lookups-Makefile b/src/scripts/lookups-Makefile
index 0617e31cd..6555e820c 100755
--- a/src/scripts/lookups-Makefile
+++ b/src/scripts/lookups-Makefile
@@ -101,7 +101,8 @@ want_dynamic() {
 
 want_at_all() {
   local want_name="$1"
-  local re="(LOOKUP|EXPERIMENTAL)_${want_name}[ $tab]*=[ $tab]*."
+  # SUPPORT is here purely for the spf lookup
+  local re="(LOOKUP|EXPERIMENTAL|SUPPORT)_${want_name}[ $tab]*=[ $tab]*."
   env | ${egrep} -q "^$re"
   if [ $? -eq 0 ]; then return 0; fi
   ${egrep} -q "^[ $tab]*$re" "$defs_source"
@@ -156,23 +157,18 @@ exec > "$target"
 sed -n "1,/$tag_marker/p" < "$input"
 
 for name_mod in \
-    CDB DBM:dbmdb DNSDB DSEARCH IBASE JSON LMDB LDAP LSEARCH MYSQL NIS NISPLUS \
-    NMH ORACLE PASSWD PGSQL REDIS SQLITE TESTDB WHOSON
+    CDB DBM:dbmdb DNSDB DSEARCH JSON LMDB LDAP LSEARCH MYSQL NIS NISPLUS \
+    NMH ORACLE PASSWD PGSQL PSL REDIS SQLITE SPF TESTDB WHOSON
 do
   emit_module_rule $name_mod
 done
 
-# Because the variable is SUPPORT_SPF and not LOOKUP_SPF we
-# always include spf.o and compile a dummy if SUPPORT_SPF is not
-# defined.
-
-OBJ="${OBJ} spf.o"
-
 # readsock is always wanted as it implements the ${readsock } expansion
-OBJ="${OBJ} readsock.o"
+OBJ_ALWAYS="${OBJ_ALWAYS} readsock.o"
 
 echo "MODS = $MODS"
 echo "OBJ = $OBJ"
+echo "OBJ_ALWAYS = $OBJ_ALWAYS"
 
 sed -n "/$tag_marker/,\$p" < "$input"
 
diff --git a/src/src/EDITME b/src/src/EDITME
index 3a9b167de..998406359 100644
--- a/src/src/EDITME
+++ b/src/src/EDITME
@@ -436,7 +436,6 @@ LOOKUP_DNSDB=yes
 
 # LOOKUP_CDB=yes
 # LOOKUP_DSEARCH=yes
-# LOOKUP_IBASE=yes
 # LOOKUP_JSON=yes
 # LOOKUP_LDAP=yes
 # LOOKUP_LMDB=yes
@@ -448,6 +447,7 @@ LOOKUP_DNSDB=yes
 # LOOKUP_ORACLE=yes
 # LOOKUP_PASSWD=yes
 # LOOKUP_PGSQL=yes
+# LOOKUP_PSL=yes
 # LOOKUP_REDIS=yes
 # LOOKUP_SQLITE=yes
 # LOOKUP_SQLITE_PC=sqlite3
@@ -461,9 +461,6 @@ LOOKUP_DNSDB=yes
 # LOOKUP_NWILDLSEARCH=yes
 
 
-# For IBASE you may need:
-#LIBS += -lfbclient
-
 #------------------------------------------------------------------------------
 # If you have set LOOKUP_LDAP, you should set LDAP_LIB_TYPE to indicate
 # which LDAP library you have. Unfortunately, though most of their functions
@@ -512,7 +509,7 @@ SUPPORT_DANE=yes
 # the command for linking Exim itself, not on any auxiliary programs. You
 # don't need to set LOOKUP_INCLUDE if the relevant directories are already
 # specified in INCLUDE. The settings below are just examples; -lpq is for
-# PostgreSQL, -lgds is for Interbase, -lsqlite3 is for SQLite, -lhiredis
+# PostgreSQL, -lsqlite3 is for SQLite, -lhiredis
 # is for Redis, -ljansson for JSON.
 #
 # You do not need to use this for any lookup information added via pkg-config.
@@ -526,15 +523,16 @@ SUPPORT_DANE=yes
 
 # LOOKUP_INCLUDE=-I /usr/local/ldap/include -I /usr/local/mysql/include -I /usr/local/pgsql/include
 # LOOKUP_INCLUDE +=-I /usr/local/include
-# LOOKUP_LIBS=-L/usr/local/lib -lldap -llber -lmysqlclient -lpq -lgds -lsqlite3 -llmdb
+# LOOKUP_LIBS=-L/usr/local/lib -lldap -llber -lmysqlclient -lpq -lsqlite3 -llmdb
 
 # LOOKUP_LIBS=-L/usr/local/lib -lldap -llber
 # Some platforms may need this for LOOKUP_NIS:
 #LOOKUP_LIBS += -lnsl
+
+# These lookup types need appropriate libraries
 #LOOKUP_LIBS += -ljansson
 #LOOKUP_LIBS += -lhiredis
 
-#------------------------------------------------------------------------------
 # If you included LOOKUP_LMDB above you will need the library. Depending
 # on where installed you may also need an include directory
 #
@@ -542,6 +540,7 @@ SUPPORT_DANE=yes
 # LOOKUP_LIBS += -llmdb
 # For dynamic-modules builds, use instead LOOKUP_LMDB_INCLUDE & LOOKUP_LMDB_LIBS
 
+# LOOKUP_PSL will require that SUPPORT_I18N is defined (but needs no libraries)
 
 #------------------------------------------------------------------------------
 # Compiling the Exim monitor: If you want to compile the Exim monitor, a
@@ -694,15 +693,6 @@ DISABLE_MAL_MKS=yes
 # support.  You must have SPF and DKIM support enabled also.
 # EXPERIMENTAL_ARC=yes
 
-# Uncomment the following lines to add Brightmail AntiSpam support. You need
-# to have the Brightmail client SDK installed. Please check the experimental
-# documentation for implementation details. You need to edit the CFLAGS and
-# LDFLAGS lines.
-
-# EXPERIMENTAL_BRIGHTMAIL=yes
-# CFLAGS  += -I/opt/brightmail/bsdk-6.0/include
-# LDFLAGS += -lxml2_single -lbmiclient_single -L/opt/brightmail/bsdk-6.0/lib
-
 # Uncomment the following to include extra information in fail DSN message (bounces)
 # EXPERIMENTAL_DSN_INFO=yes
 
diff --git a/src/src/acl.c b/src/src/acl.c
index 80a17c937..36fb850c8 100644
--- a/src/src/acl.c
+++ b/src/src/acl.c
@@ -63,9 +63,6 @@ enum { ACLC_ACL,
        ACLC_ADD_HEADER,
        ACLC_ATRN_DOMAINS,
        ACLC_AUTHENTICATED,
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-       ACLC_BMI_OPTIN,
-#endif
        ACLC_CONDITION,
        ACLC_CONTINUE,
        ACLC_CONTROL,
@@ -168,19 +165,6 @@ static condition_def conditions[] = {
 				    ACL_BIT_NOTSMTP_START |
 				    ACL_BIT_CONNECT | ACL_BIT_HELO),
   },
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-  [ACLC_BMI_OPTIN] =		{ US"bmi_optin",	ACD_EXP | ACD_MOD,
-				  FORBIDDEN(ACL_BIT_AUTH |
-				    ACL_BIT_CONNECT | ACL_BIT_HELO |
-				    ACL_BIT_DATA | ACL_BIT_MIME |
-				    ACL_BIT_PRDR |
-				    ACL_BIT_ETRN | ACL_BIT_EXPN |
-				    ACL_BIT_MAILAUTH |
-				    ACL_BIT_MAIL | ACL_BIT_STARTTLS |
-				    ACL_BIT_VRFY | ACL_BIT_PREDATA |
-				    ACL_BIT_NOTSMTP_START),
-  },
-#endif
   [ACLC_CONDITION] =		{ US"condition",	ACD_EXP,
 				  FORBIDDEN(0) },
   [ACLC_CONTINUE] =		{ US"continue",		ACD_EXP | ACD_MOD,
@@ -433,9 +417,6 @@ static condition_module condition_modules[] = {
 
 enum {
   CONTROL_AUTH_UNADVERTISED,
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-  CONTROL_BMI_RUN,
-#endif
   CONTROL_CASEFUL_LOCAL_PART,
   CONTROL_CASELOWER_LOCAL_PART,
   CONTROL_CUTTHROUGH_DELIVERY,
@@ -493,10 +474,6 @@ static control_def controls_list[] = {
 				  (unsigned)
 				  ~(ACL_BIT_CONNECT | ACL_BIT_HELO)
   },
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-[CONTROL_BMI_RUN] =
-  { US"bmi_run",                 FALSE,		0 },
-#endif
 [CONTROL_CASEFUL_LOCAL_PART] =
   { US"caseful_local_part",      FALSE, (unsigned) ~ACL_BIT_RCPT },
 [CONTROL_CASELOWER_LOCAL_PART] =
@@ -3460,17 +3437,6 @@ for (; cb; cb = cb->next)
 	      &arg, 0, NULL, NULL, MCL_STRING, TRUE, NULL) : FAIL;
       break;
 
-    #ifdef EXPERIMENTAL_BRIGHTMAIL
-    case ACLC_BMI_OPTIN:
-      {
-      int old_pool = store_pool;
-      store_pool = POOL_PERM;
-      bmi_current_optin = string_copy(arg);
-      store_pool = old_pool;
-      }
-    break;
-    #endif
-
     case ACLC_CONDITION:
     /* The true/false parsing here should be kept in sync with that used in
     expand.c when dealing with ECOND_BOOL so that we don't have too many
@@ -3512,12 +3478,6 @@ for (; cb; cb = cb->next)
 	  f.allow_auth_unadvertised = TRUE;
 	  break;
 
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-	case CONTROL_BMI_RUN:
-	  bmi_run = 1;
-	  break;
-#endif
-
 #ifndef DISABLE_DKIM
 	case CONTROL_DKIM_VERIFY:
 	  f.dkim_disable_verify = TRUE;
diff --git a/src/src/auths/cram_md5.c b/src/src/auths/cram_md5.c
index df861f6c4..2f6a56626 100644
--- a/src/src/auths/cram_md5.c
+++ b/src/src/auths/cram_md5.c
@@ -343,7 +343,7 @@ auth_info cram_md5_auth_info = {
   .options_block =	&auth_cram_md5_option_defaults,
   .options_len =	sizeof(auth_cram_md5_options_block),
   .init =		auth_cram_md5_init,
-# ifdef DYNLOOKUP
+# if AUTH_CRAM_MD5==2
   .dyn_magic =		AUTH_MAGIC,
 # endif
   },
diff --git a/src/src/auths/cyrus_sasl.c b/src/src/auths/cyrus_sasl.c
index 8d39945bc..0ccb1f5fe 100644
--- a/src/src/auths/cyrus_sasl.c
+++ b/src/src/auths/cyrus_sasl.c
@@ -521,7 +521,7 @@ auth_info cyrus_sasl_auth_info = {
   .options_block =	&auth_cyrus_sasl_option_defaults,
   .options_len =	sizeof(auth_cyrus_sasl_options_block),
   .init =		auth_cyrus_sasl_init,
-# ifdef DYNLOOKUP
+# if AUTH_CYRUS_SASL==2
   .dyn_magic =		AUTH_MAGIC,
 # endif
   },
diff --git a/src/src/auths/dovecot.c b/src/src/auths/dovecot.c
index 5319878e2..118e95f29 100644
--- a/src/src/auths/dovecot.c
+++ b/src/src/auths/dovecot.c
@@ -564,7 +564,7 @@ auth_info dovecot_auth_info = {
   .options_block =	&auth_dovecot_option_defaults,
   .options_len =	sizeof(auth_dovecot_options_block),
   .init =		auth_dovecot_init,
-# ifdef DYNLOOKUP
+# if AUTH_DOVECOT==2
   .dyn_magic =		AUTH_MAGIC,
 # endif
   },
diff --git a/src/src/auths/external.c b/src/src/auths/external.c
index 0cdfcdcfe..883c9cae8 100644
--- a/src/src/auths/external.c
+++ b/src/src/auths/external.c
@@ -172,7 +172,7 @@ auth_info external_auth_info = {
   .options_block =	&auth_external_option_defaults,
   .options_len =	sizeof(auth_external_options_block),
   .init =		auth_external_init,
-# ifdef DYNLOOKUP
+# if AUTH_EXTERNAL==2
   .dyn_magic =		AUTH_MAGIC,
 # endif
   },
diff --git a/src/src/auths/gsasl.c b/src/src/auths/gsasl.c
index 9c315fc92..ad4c9b479 100644
--- a/src/src/auths/gsasl.c
+++ b/src/src/auths/gsasl.c
@@ -1073,7 +1073,7 @@ auth_info gsasl_auth_info = {
   .options_block =	&auth_gsasl_option_defaults,
   .options_len =	sizeof(auth_gsasl_options_block),
   .init =		auth_gsasl_init,
-# ifdef DYNLOOKUP
+# if AUTH_GSASL==2
   .dyn_magic =		AUTH_MAGIC,
 # endif
   },
diff --git a/src/src/auths/heimdal_gssapi.c b/src/src/auths/heimdal_gssapi.c
index 8014e61bb..1c79112c3 100644
--- a/src/src/auths/heimdal_gssapi.c
+++ b/src/src/auths/heimdal_gssapi.c
@@ -625,7 +625,7 @@ auth_info heimdal_gssapi_auth_info = {
   .options_block =	&auth_heimdal_gssapi_option_defaults,
   .options_len =	sizeof(auth_heimdal_gssapi_options_block),
   .init =		auth_heimdal_gssapi_init,
-# ifdef DYNLOOKUP
+# if AUTH_HEIMDAL_GSSAPI==2
   .dyn_magic =		AUTH_MAGIC,
 # endif
   },
diff --git a/src/src/auths/plaintext.c b/src/src/auths/plaintext.c
index 598311e65..772b49ff9 100644
--- a/src/src/auths/plaintext.c
+++ b/src/src/auths/plaintext.c
@@ -194,7 +194,7 @@ auth_info plaintext_auth_info = {
   .options_block =	&auth_plaintext_option_defaults,
   .options_len =	sizeof(auth_plaintext_options_block),
   .init =		auth_plaintext_init,
-# ifdef DYNLOOKUP
+# if AUTH_PLAINTEXT==2
   .dyn_magic =		AUTH_MAGIC,
 # endif
   },
@@ -204,5 +204,5 @@ auth_info plaintext_auth_info = {
 .macros_create =	NULL,
 };
 
-#endif	/*AUTH_PLAINTEST*/
+#endif	/*AUTH_PLAINTEXT*/
 /* End of plaintext.c */
diff --git a/src/src/auths/spa.c b/src/src/auths/spa.c
index 8bd95813e..3e2cccde9 100644
--- a/src/src/auths/spa.c
+++ b/src/src/auths/spa.c
@@ -389,7 +389,7 @@ auth_info spa_auth_info = {
   .options_block =	&auth_spa_option_defaults,
   .options_len =	sizeof(auth_spa_options_block),
   .init =		auth_spa_init,
-# ifdef DYNLOOKUP
+# if AUTH_SPA==2
   .dyn_magic =		AUTH_MAGIC,
 # endif
   },
diff --git a/src/src/auths/tls.c b/src/src/auths/tls.c
index b427d29aa..d44750098 100644
--- a/src/src/auths/tls.c
+++ b/src/src/auths/tls.c
@@ -108,7 +108,7 @@ auth_info tls_auth_info = {
   .options_block =	&auth_tls_option_defaults,
   .options_len =	sizeof(auth_tls_options_block),
   .init =		auth_tls_init,
-# ifdef DYNLOOKUP
+# if AUTH_TLS==2
   .dyn_magic =		AUTH_MAGIC,
 # endif
   },
diff --git a/src/src/config.h.defaults b/src/src/config.h.defaults
index ebf67ad57..05bdcd6d3 100644
--- a/src/src/config.h.defaults
+++ b/src/src/config.h.defaults
@@ -102,7 +102,6 @@ Do not put spaces between # and the 'define'.
 #define LOOKUP_DBM
 #define LOOKUP_DNSDB
 #define LOOKUP_DSEARCH
-#define LOOKUP_IBASE
 #define LOOKUP_JSON
 #define LOOKUP_LDAP
 #define LOOKUP_LMDB
@@ -113,6 +112,7 @@ Do not put spaces between # and the 'define'.
 #define LOOKUP_ORACLE
 #define LOOKUP_PASSWD
 #define LOOKUP_PGSQL
+#define LOOKUP_PSL
 #define LOOKUP_REDIS
 #define LOOKUP_SQLITE
 #define LOOKUP_TESTDB
@@ -217,7 +217,6 @@ Do not put spaces between # and the 'define'.
 
 /* EXPERIMENTAL features */
 #define EXPERIMENTAL_ARC
-#define EXPERIMENTAL_BRIGHTMAIL
 #define EXPERIMENTAL_DCC
 #define EXPERIMENTAL_DSN_INFO
 #define EXPERIMENTAL_NMH
diff --git a/src/src/configure.default b/src/src/configure.default
index 633c6539e..c05ed182e 100644
--- a/src/src/configure.default
+++ b/src/src/configure.default
@@ -260,21 +260,6 @@ host_lookup = *
 dns_dnssec_ok = 1
 
 
-# The settings below cause Exim to make RFC 1413 (ident) callbacks
-# for all incoming SMTP calls. You can limit the hosts to which these
-# calls are made, and/or change the timeout that is used. If you set
-# the timeout to zero, all RFC 1413 calls are disabled. RFC 1413 calls
-# are cheap and can provide useful information for tracing problem
-# messages, but some hosts and firewalls have problems with them.
-# This can result in a timeout instead of an immediate refused
-# connection, leading to delays on starting up SMTP sessions.
-# (The default was reduced from 30s to 5s for release 4.61. and to
-# disabled for release 4.86)
-#
-#rfc1413_hosts = *
-#rfc1413_query_timeout = 5s
-
-
 # Enable an efficiency feature.  We advertise the feature; clients
 # may request to use it.  For multi-recipient mails we then can
 # reject or accept per-user after the message is received.
diff --git a/src/src/daemon.c b/src/src/daemon.c
index a31ef1eb5..824fe0187 100644
--- a/src/src/daemon.c
+++ b/src/src/daemon.c
@@ -479,20 +479,9 @@ if (pid == 0)
   signal(SIGTERM, SIG_DFL);
   signal(SIGINT, SIG_DFL);
 
-  /* Attempt to get an id from the sending machine via the RFC 1413
-  protocol. We do this in the sub-process in order not to hold up the
-  main process if there is any delay. Then set up the fullhost information
-  in case there is no HELO/EHLO.
+  /* Set up the fullhost information in case there is no HELO/EHLO. */
 
-  If debugging is enabled only for the daemon, we must turn if off while
-  finding the id, but turn it on again afterwards so that information about the
-  incoming connection is output. */
-
-  if (f.debug_daemon) debug_selector = 0;
-  verify_get_ident(IDENT_PORT);
   host_build_sender_fullhost();
-  debug_selector = save_debug_selector;
-
   DEBUG(D_any)
     debug_printf("Process %d is handling incoming connection from %s\n",
       (int)getpid(), sender_fullhost);
diff --git a/src/src/deliver.c b/src/src/deliver.c
index 21a610859..497c62e81 100644
--- a/src/src/deliver.c
+++ b/src/src/deliver.c
@@ -206,13 +206,6 @@ router_var = addr->prop.variables;
 deliver_domain = addr->domain;
 self_hostname = addr->self_hostname;
 
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-bmi_deliver = 1;    /* deliver by default */
-bmi_alt_location = NULL;
-bmi_base64_verdict = NULL;
-bmi_base64_tracker_verdict = NULL;
-#endif
-
 /* If there's only one address we can set everything. */
 
 if (!addr->next)
@@ -269,17 +262,6 @@ if (!addr->next)
       }
     }
 
-#ifdef EXPERIMENTAL_BRIGHTMAIL
-    /* Set expansion variables related to Brightmail AntiSpam */
-    bmi_base64_verdict = bmi_get_base64_verdict(deliver_localpart_orig, deliver_domain_orig);
-    bmi_base64_tracker_verdict = bmi_get_base64_tracker_verdict(bmi_base64_verdict);
-    /* get message delivery status (0 - don't deliver | 1 - deliver) */
-    bmi_deliver = bmi_get_delivery_status(bmi_base64_verdict);
-    /* if message is to be delivered, get eventual alternate location */
-    if (bmi_deliver == 1)
-      bmi_alt_location = bmi_get_alt_location(bmi_base64_verdict);
-#endif
-
   }
 
 /* For multiple addresses, don't set local part, and leave the domain and
@@ -1059,7 +1041,7 @@ else
     s = addr->domain;
 #ifdef SUPPORT_I18N
     if (testflag(addr, af_utf8_downcvt))
-      s = string_localpart_utf8_to_alabel(s, NULL);
+      s = string_domain_utf8_to_alabel(US s, NULL);
 #endif
     g = string_cat(g, s);
     }
@@ -2656,10 +2638,12 @@ if (addr->special_action == SPECIAL_WARN)
 
 /* Check transport for the given concurrency limit.  Return TRUE if over
 the limit (or an expansion failure), else FALSE and if there was a limit,
-the key for the hints database used for the concurrency count. */
+the key for the hints database used for the concurrency count
+and a string for observability. */
 
 static BOOL
-tpt_parallel_check(transport_instance * tp, address_item * addr, uschar ** key)
+tpt_parallel_check(const transport_instance * tp, address_item * addr,
+  uschar ** key, uschar ** state)
 {
 const uschar * trname = tp->drinst.name;
 unsigned max_parallel;
@@ -2679,22 +2663,22 @@ if (expand_string_message)
 if (max_parallel > 0)
   {
   uschar * serialize_key = string_sprintf("tpt-serialize-%s", trname);
-  if (!enq_start(serialize_key, max_parallel))
+  unsigned running;
+  if (!(running = enq_start(serialize_key, max_parallel)))
     {
-    address_item * next;
     DEBUG(D_transport)
       debug_printf("skipping tpt %s because concurrency limit %u reached\n",
 		  trname, max_parallel);
     do
       {
-      next = addr->next;
       addr->message = US"concurrency limit reached for transport";
       addr->basic_errno = ERRNO_TRETRY;
       post_process_one(addr, DEFER, LOG_MAIN, EXIM_DTYPE_TRANSPORT, 0);
-      } while ((addr = next));
+      } while ((addr = addr->next));
     return TRUE;
     }
   *key = serialize_key;
+  *state = string_sprintf(" (%u/max_parallel:%u)", running, max_parallel);
   }
 return FALSE;
 }
@@ -2731,7 +2715,7 @@ while (addr_local)
   int logflags = LOG_MAIN;
   int logchar = f.dont_deliver? '*' : '=';
   transport_instance * tp;
-  uschar * serialize_key = NULL;
+  uschar * serialize_key = NULL, * tpt_dummy;
   const uschar * trname;
 
   /* Pick the first undelivered address off the chain */
@@ -3018,7 +3002,7 @@ while (addr_local)
   We use a hints DB entry, incremented here and decremented after
   the transport (and any shadow transport) completes. */
 
-  if (tpt_parallel_check(tp, addr, &serialize_key))
+  if (tpt_parallel_check(tp, addr, &serialize_key, &tpt_dummy))
     {
     if (expand_string_message)
       {
@@ -3996,20 +3980,22 @@ can be created, or when waiting for the last ones to complete. It must wait for
 the completion of one subprocess, empty the control block slot, and return a
 pointer to the address chain.
 
-Arguments:    none
-Returns:      pointer to the chain of addresses handled by the process;
-              NULL if no subprocess found - this is an unexpected error
+Arguments:
+  reason:	observability: reason for call
+
+Returns:	pointer to the chain of addresses handled by the process;
+		NULL if no subprocess found - this is an unexpected error
 */
 
 static address_item *
-par_wait(void)
+par_wait(const uschar * reason)
 {
 int poffset, status;
 address_item * addrlist;
 pid_t pid;
 
 set_process_info("delivering %s: waiting for a remote delivery subprocess "
-  "to finish", message_id);
+  "to finish (%s)", message_id, reason);
 
 /* Loop until either a subprocess completes, or there are no subprocesses in
 existence - in which case give an error return. We cannot proceed just by
@@ -4256,16 +4242,17 @@ log and proceed as if all done.
 Arguments:
   max         maximum number of subprocesses to leave running
   fallback    TRUE if processing fallback hosts
+  reason      observability: reason for call
 
 Returns:      nothing
 */
 
 static void
-par_reduce(int max, BOOL fallback)
+par_reduce(int max, BOOL fallback, const uschar * reason)
 {
 while (parcount > max)
   {
-  address_item * doneaddr = par_wait();
+  address_item * doneaddr = par_wait(reason);
   if (!doneaddr)
     {
     log_write(0, LOG_MAIN|LOG_PANIC,
@@ -4357,6 +4344,7 @@ static BOOL
 do_remote_deliveries(BOOL fallback)
 {
 int parmax, poffset;
+const uschar * plimit_reason = US"remote_max_parallel";
 
 parcount = 0;    /* Number of executing subprocesses */
 
@@ -4364,7 +4352,8 @@ parcount = 0;    /* Number of executing subprocesses */
 We use a local variable (parmax) to hold the maximum number of processes;
 this gets reduced from remote_max_parallel if we can't create enough pipes. */
 
-if (continue_transport) remote_max_parallel = 1;
+if (continue_transport)
+  { remote_max_parallel = 1; plimit_reason = US"continue_transport"; }
 parmax = remote_max_parallel;
 
 /* If the data for keeping a list of processes hasn't yet been
@@ -4388,12 +4377,12 @@ for (int delivery_count = 0; addr_remote; delivery_count++)
   uid_t uid;
   gid_t gid;
   int pfd[2];
-  int address_count = 1, address_count_max;
+  unsigned address_count = 1, address_count_max;
   BOOL pipe_done = FALSE, multi_domain, use_initgroups;
   transport_instance * tp;
   address_item ** anchor = &addr_remote;
   address_item * addr = addr_remote, * last = addr, * next;
-  uschar * serialize_key = NULL, * panicmsg;
+  uschar * serialize_key = NULL, * tpt_parallel_level, * panicmsg;
 
   /* Pull the first address right off the list. */
 
@@ -4457,7 +4446,7 @@ So look out for the place it gets used.
   unlimited, which is forced for the MUA wrapper case and if the
   value could vary depending on the messages.
   For those, we only split (below) by (tpt,dest,erraddr,hdrs) and rely on the
-  transport splitting further by max_rcp.  So we potentially lose some
+  transport splitting further by max_rcpt.  So we potentially lose some
   parallellism. */
 
   GET_OPTION("max_rcpt");
@@ -4573,7 +4562,8 @@ Does that also apply to address_data?
       last = next;
       address_count++;
       }
-    else anchor = &(next->next);
+    else
+      anchor = &next->next;
     deliver_set_expansions(NULL);
     }
 
@@ -4591,7 +4581,8 @@ Does that also apply to address_data?
   The hints DB entry is decremented in par_reduce(), when we reap the
   transport process. */
 
-  if (tpt_parallel_check(tp, addr, &serialize_key))
+  tpt_parallel_level = US"";
+  if (tpt_parallel_check(tp, addr, &serialize_key, &tpt_parallel_level))
     if ((panicmsg = expand_string_message))
       goto panic_continue;
     else
@@ -4788,9 +4779,12 @@ parmax * tpt-max is exceeded? */
 
   while (!pipe_done)
     {
-    if (socketpair(AF_UNIX, SOCK_STREAM, 0, pfd) == 0) pipe_done = TRUE;
-    else if (parcount > 0) parmax = parcount;
-    else break;
+    if (socketpair(AF_UNIX, SOCK_STREAM, 0, pfd) == 0)
+      pipe_done = TRUE;
+    else if (parcount > 0)
+      { parmax = parcount; plimit_reason = US"fildesc limit"; }
+    else
+      break;
 
     /* We need to make the reading end of the pipe non-blocking. There are
     two different options for this. Exim is cunningly (I hope!) coded so
@@ -4811,7 +4805,7 @@ all pipes, so I do not see a reason to use non-blocking IO here
     to finish. If we ran out of file descriptors, parmax will have been reduced
     from its initial value of remote_max_parallel. */
 
-    par_reduce(parmax - 1, fallback);
+    par_reduce(parmax - 1, fallback, plimit_reason);
     }
 
   /* If we failed to create a pipe and there were no processes to wait
@@ -4956,7 +4950,9 @@ do_remote_deliveries par_reduce par_wait par_read_pipe
     of bytes written. */
 
     (void)close(pfd[pipe_read]);
-    set_process_info("delivering %s using %s", message_id, tp->drinst.name);
+    set_process_info("delivering %s (%u addr%s) using %s%s",
+		    message_id, address_count, address_count>1?"s":"",
+		    tp->drinst.name, tpt_parallel_level);
     debug_print_string(tp->debug_string);
 
       {
@@ -5364,7 +5360,7 @@ do_remote_deliveries par_reduce par_wait par_read_pipe
 
   if (continue_transport)
     {
-    par_reduce(0, fallback);
+    par_reduce(0, fallback, US"continue_transport wait-complete");
     if (!*continue_next_id && continue_wait_db)
 	{ dbfn_close_multi(continue_wait_db); continue_wait_db = NULL; }
 
@@ -5393,7 +5389,7 @@ panic_continue:
 /* Reached the end of the list of addresses. Wait for all the subprocesses that
 are still running and post-process their addresses. */
 
-par_reduce(0, fallback);
+par_reduce(0, fallback, US"delivery wait-all-complete");
 return TRUE;
 }
 
diff --git a/src/src/dns.c b/src/src/dns.c
index 4c8f1dd14..dd754f6c9 100644
--- a/src/src/dns.c
+++ b/src/src/dns.c
@@ -841,15 +841,14 @@ if ((rc = dns_fail_cache_hit(name, type)) > 0)
 #ifdef SUPPORT_I18N
 /* Convert all names to a-label form before doing lookup */
   {
-  uschar * alabel;
+  const uschar * alabel;
   uschar * errstr = NULL;
   DEBUG(D_dns) if (string_is_utf8(name))
     debug_printf_indent("convert utf8 '%s' to alabel for for lookup\n", name);
   if ((alabel = string_domain_utf8_to_alabel(name, &errstr)), errstr)
     {
-    DEBUG(D_dns)
-      debug_printf_indent("DNS name '%s' utf8 conversion to alabel failed: %s\n", name,
-        errstr);
+    DEBUG(D_dns) debug_printf_indent(
+      "DNS name '%s' utf8 conversion to alabel failed: %s\n", name, errstr);
     f.host_find_failed_syntax = TRUE;
     return DNS_NOMATCH;
     }
